//
// Patch for DataGrid for Header
// Provided "As is"
// by PhilFlash - http://philflash.inway.fr
// More information : http://philflash.inway.fr/dgheader/
//
// version 1.0 - 15 septembre 2004
//
// Define new style properties to change the appearance of a DataGrid header.
// 
// headerUIStyle: The style of the column header : either "normal", "solid", or "roundcorner". 
//                The default value is "normal". 
//                If the value is "roundcorner", the borderStyle of the datagrid must be "none" [datagrid.setStyle("borderStyle" , "none");]
//
// headerSelectionColor: The color of header when the mouse pointer rolls over it.
//
// headerBottomColor: The color of the separator between the header and the rows.
//
// headerBackgroundColor: The background color of the header when the headerUIStyle is "roundcorner". The default color is white
//

mx.controls.DataGrid["prototype"]["drawHeaderBG"] = function () {
		var mc : MovieClip = this.header_mc;
		mc.clear();
		var clr : Number = this.getStyle("headerColor");
		var o : Object = this.__viewMetrics;
		var tot : Number = Math.max(this.totalWidth, this.displayWidth+3);
		
		var uiStyle = this.getStyle("headerUIStyle");
		if (uiStyle == undefined) uiStyle = "normal";
		if (uiStyle != "solid" && uiStyle != "roundcorner") uiStyle = "normal";

		var bottomColor = this.getStyle("headerBottomColor");
		if (bottomColor == undefined) headerBottomColor = 0x000000;
		
		if (uiStyle == "normal") {
			mc.moveTo(o.left,o.top);
			var matrix : Object = { matrixType : "box", x:0, y:0, w:tot, h:this.__headerHeight+1, r:Math.PI/2 };
			var colors : Array = [clr, clr, 0xffffff];
			var ratios : Array = [0, 60, 255];
			var alphas : Array = [100, 100, 100];
			mc.beginGradientFill("linear", colors, alphas, ratios, matrix);
	
			mc.lineStyle(0, 0x000000, 0);
			mc.lineTo(tot, o.top);
			mc.lineTo(tot, this.__headerHeight+1);
			mc.lineStyle(0, bottomColor, 100);
			mc.lineTo(o.left, this.__headerHeight+1);
			mc.lineStyle(0, 0x000000, 0);
			mc.endFill();
		} else if (uiStyle == "solid") {
			mc.moveTo(o.left,o.top);
			mc.beginFill(clr);
			mc.lineStyle(0, 0x000000, 0);
			mc.lineTo(tot, o.top);
			mc.lineTo(tot, this.__headerHeight+1);
			mc.lineStyle(0, bottomColor, 100);
			mc.lineTo(o.left, this.__headerHeight+1);
			mc.lineStyle(0, 0x000000, 0);
			mc.endFill();
		} else {
			tot = this.totalWidth;
			// draw background
			var backColor = this.getStyle("headerBackgroundColor");
			if (backColor == undefined) backColor = 0xFFFFFF;
			mc.beginFill(backColor);
			mc.lineStyle(0, 0x000000, 0);
			mc.lineTo(tot, o.top);
			mc.lineTo(tot, this.__headerHeight+1);
			mc.lineStyle(0, bottomColor, 100);
			mc.lineTo(o.left, this.__headerHeight+1);
			mc.lineStyle(0, 0x000000, 0);
			mc.endFill();			
			// draw round rectangle
	   		var __cornerRadius:Number = 8;
			with (mc) {
				drawRoundRect(0,0,tot,this.__headerHeight+1,{br:0,bl:0,tl:__cornerRadius,tr:__cornerRadius}, clr, 100);
			}
		}
}

mx.controls.DataGrid["prototype"]["headerRollOver"] = function()
{
		var o = this.owner; // the grid
		if (!o.enabled || o.cellEditor!=undefined || !o.sortableColumns || !this.column.sortable) return;
		var c = new Color(this);
		var col = o.getStyle("headerSelectionColor");
		if (col == undefined) col = o.getStyle("rollOverColor");
		c.setRGB(col);
		this._alpha = 50;
}
	
mx.controls.DataGrid["prototype"]["headerPress"] = function()
{
	var o = this.owner; // the grid
	if (!this.column.sortable || !o.sortableColumns || !o.enabled) return;
	this.cell._x+=1;
	this.cell._y+=1;
	var c = new Color(this);
	var col = o.getStyle("headerSelectionColor");
	if (col == undefined) col = o.getStyle("selectionColor");
	c.setRGB(col);
	this._alpha = 100;

}
